Index: P/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/scripts/proba-ndsproperties.xml
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/scripts/proba-ndsproperties.xml	(revision 777)
+++ 	(revision )
@@ -1,9 +1,0 @@
-<?xml version="1.0" encoding="utf-8"?>
-<NDSProject xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.0" supplier="Nokia">
-  <updateMmpFile>true</updateMmpFile>
-  <pkgFile>sis\proba.pkg</pkgFile>
-  <pkgUpdate>true</pkgUpdate>
-  <pkgGeneration>true</pkgGeneration>
-  <lang>EN</lang>
-  <updateContextHelp>true</updateContextHelp>
-</NDSProject>
Index: P/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/scripts/OgreMemory.log
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/scripts/OgreMemory.log	(revision 777)
+++ 	(revision )
@@ -1,29 +1,0 @@
---------------------------------------------------------------------------------
-
-      OgreMemory.log - Memory logging file created on Wed Jul 06 13:54:56 2005
-
---------------------------------------------------------------------------------
-
-This file contains a log of all memory operations performed during the last run.
-
-Interrogate this file to track errors or to help track down memory-related
-issues. You can do this by tracing the allocations performed by a specific owner
-or by tracking a specific address through a series of allocations and
-reallocations.
-
-There is a lot of useful information here which, when used creatively, can be
-extremely helpful.
-
-Note that the following guides are used throughout this file:
-
-   [!] - Error
-   [+] - Allocation
-   [~] - Reallocation
-   [-] - Deallocation
-   [I] - Generic information
-   [F] - Failure induced for the purpose of stress-testing your application
-   [D] - Information used for debugging this memory manager
-
-...so, to find all errors in the file, search for "[!]"
-
---------------------------------------------------------------------------------
Index: P/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/scripts/Demo_Lighting-ndsproperties.xml
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/scripts/Demo_Lighting-ndsproperties.xml	(revision 777)
+++ 	(revision )
@@ -1,9 +1,0 @@
-<?xml version="1.0" encoding="utf-8"?>
-<NDSProject xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.0" supplier="Nokia">
-  <updateMmpFile>true</updateMmpFile>
-  <pkgFile>sis\Demo_Lighting.pkg</pkgFile>
-  <pkgUpdate>true</pkgUpdate>
-  <pkgGeneration>true</pkgGeneration>
-  <lang>EN</lang>
-  <updateContextHelp>true</updateContextHelp>
-</NDSProject>
Index: P/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/scripts/Demo_Lighting.vcproj.old
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/scripts/Demo_Lighting.vcproj.old	(revision 777)
+++ 	(revision )
@@ -1,144 +1,0 @@
-<?xml version="1.0" encoding = "windows-1250"?>
-<VisualStudioProject
-	ProjectType="Visual C++"
-	Version="7.00"
-	Name="Demo_Lighting"
-	ProjectGUID="{09F9E809-02CF-4926-8203-2B9C02FBD916}"
-	Keyword="Win32Proj">
-	<Platforms>
-		<Platform
-			Name="Win32"/>
-	</Platforms>
-	<Configurations>
-		<Configuration
-			Name="Debug|Win32"
-			OutputDirectory="..\bin\$(ConfigurationName)"
-			IntermediateDirectory="..\obj\$(ConfigurationName)"
-			ConfigurationType="1"
-			CharacterSet="2">
-			<Tool
-				Name="VCCLCompilerTool"
-				Optimization="0"
-				ImproveFloatingPointConsistency="TRUE"
-				AdditionalIncludeDirectories="..\include;..\..\Common\include;..\..\..\OgreMain\include"
-				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;"
-				MinimalRebuild="TRUE"
-				BasicRuntimeChecks="3"
-				RuntimeLibrary="3"
-				EnableFunctionLevelLinking="TRUE"
-				UsePrecompiledHeader="0"
-				WarningLevel="3"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="4"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLinkerTool"
-				AdditionalDependencies="OgreMain_d.lib"
-				OutputFile="$(OutDir)/Demo_Lighting.exe"
-				LinkIncremental="2"
-				AdditionalLibraryDirectories="&quot;..\..\..\OgreMain\lib\$(ConfigurationName)&quot;"
-				GenerateDebugInformation="TRUE"
-				ProgramDatabaseFile="$(OutDir)/Demo_Lighting.pdb"
-				SubSystem="2"
-				OptimizeForWindows98="1"
-				TargetMachine="1"/>
-			<Tool
-				Name="VCMIDLTool"/>
-			<Tool
-				Name="VCPostBuildEventTool"
-				CommandLine="copy $(OutDir)\$(TargetFileName) ..\..\Common\Bin\$(ConfigurationName)"/>
-			<Tool
-				Name="VCPreBuildEventTool"/>
-			<Tool
-				Name="VCPreLinkEventTool"/>
-			<Tool
-				Name="VCResourceCompilerTool"/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"/>
-			<Tool
-				Name="VCWebDeploymentTool"/>
-		</Configuration>
-		<Configuration
-			Name="Release|Win32"
-			OutputDirectory="..\bin\$(ConfigurationName)"
-			IntermediateDirectory="..\obj\$(ConfigurationName)"
-			ConfigurationType="1"
-			CharacterSet="2"
-			WholeProgramOptimization="TRUE">
-			<Tool
-				Name="VCCLCompilerTool"
-				Optimization="2"
-				GlobalOptimizations="TRUE"
-				InlineFunctionExpansion="1"
-				EnableIntrinsicFunctions="TRUE"
-				ImproveFloatingPointConsistency="TRUE"
-				FavorSizeOrSpeed="1"
-				OmitFramePointers="TRUE"
-				OptimizeForProcessor="2"
-				OptimizeForWindowsApplication="TRUE"
-				AdditionalIncludeDirectories="..\include;..\..\Common\include;..\..\..\OgreMain\include"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS"
-				StringPooling="TRUE"
-				MinimalRebuild="TRUE"
-				RuntimeLibrary="2"
-				BufferSecurityCheck="FALSE"
-				EnableFunctionLevelLinking="TRUE"
-				UsePrecompiledHeader="0"
-				WarningLevel="3"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLinkerTool"
-				AdditionalDependencies="OgreMain.lib"
-				OutputFile="$(OutDir)/Demo_Lighting.exe"
-				LinkIncremental="1"
-				AdditionalLibraryDirectories="&quot;..\..\..\OgreMain\lib\$(ConfigurationName)&quot;"
-				GenerateDebugInformation="FALSE"
-				SubSystem="2"
-				OptimizeReferences="2"
-				EnableCOMDATFolding="2"
-				OptimizeForWindows98="1"
-				TargetMachine="1"/>
-			<Tool
-				Name="VCMIDLTool"/>
-			<Tool
-				Name="VCPostBuildEventTool"
-				CommandLine="copy $(OutDir)\$(TargetFileName) ..\..\Common\Bin\$(ConfigurationName)"/>
-			<Tool
-				Name="VCPreBuildEventTool"/>
-			<Tool
-				Name="VCPreLinkEventTool"/>
-			<Tool
-				Name="VCResourceCompilerTool"/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"/>
-			<Tool
-				Name="VCWebDeploymentTool"/>
-		</Configuration>
-	</Configurations>
-	<Files>
-		<Filter
-			Name="Source Files"
-			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm">
-			<File
-				RelativePath="..\src\Lighting.cpp">
-			</File>
-		</Filter>
-		<Filter
-			Name="Header Files"
-			Filter="h;hpp;hxx;hm;inl;inc">
-			<File
-				RelativePath="..\include\Lighting.h">
-			</File>
-		</Filter>
-		<Filter
-			Name="Resource Files"
-			Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe">
-		</Filter>
-	</Files>
-	<Globals>
-	</Globals>
-</VisualStudioProject>
Index: P/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/scripts/Ogre.log
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/scripts/Ogre.log	(revision 777)
+++ 	(revision )
@@ -1,46 +1,0 @@
-13:54:56: Creating resource group General
-13:54:56: Registering ResourceManager for type Material
-13:54:56: Registering ResourceManager for type Mesh
-13:54:56: Registering ResourceManager for type Skeleton
-13:54:56: Loading library OgrePlatform_d.dll
-13:54:56: OverlayElementFactory for type Panel registered.
-13:54:56: OverlayElementFactory for type BorderPanel registered.
-13:54:56: OverlayElementFactory for type TextArea registered.
-13:54:56: Registering ResourceManager for type Font
-13:54:56: ArchiveFactory for archive type FileSystem registered.
-13:54:56: ArchiveFactory for archive type Zip registered.
-13:54:56: DevIL version: Developer's Image Library (DevIL) 1.6.5
-13:54:56: DevIL image formats: bmp dib cut dcx dds gif ico cur jpg jpe jpeg lif mdl mng jng pcx pic pix png pbm pgm pnm ppm psd pdd psp pxr sgi bw rgb rgba tga vda icb vst tif tiff wal xpm raw 
-13:54:56: Registering ResourceManager for type HighLevelGpuProgram
-13:54:56: An exception has been thrown!
-
------------------------------------
-Details:
------------------------------------
-Error #: 8
-Function: ConfigFile::load
-Description: 'plugins.cfg' file not found!. 
-File: c:\ogrenew\ogremain\src\ogreconfigfile.cpp
-Line: 68
-Stack unwinding: <<beginning of stack>>
-13:54:56: plugins.cfg not found, automatic plugin loading disabled.
-13:54:56: *-*-* OGRE Initialising
-13:54:56: *-*-* Version 1.0.0 (Azathoth)
-13:54:56: An exception has been thrown!
-
------------------------------------
-Details:
------------------------------------
-Error #: 8
-Function: ConfigFile::load
-Description: 'resources.cfg' file not found!. 
-File: c:\ogrenew\ogremain\src\ogreconfigfile.cpp
-Line: 68
-Stack unwinding: <<beginning of stack>>
-13:55:15: *-*-* OGRE Shutdown
-13:55:15: Unregistering ResourceManager for type Font
-13:55:15: Unregistering ResourceManager for type Skeleton
-13:55:15: Unregistering ResourceManager for type Mesh
-13:55:15: Unregistering ResourceManager for type HighLevelGpuProgram
-13:55:15: Unregistering ResourceManager for type Material
-13:55:15: Unloading library OgrePlatform_d.dll
Index: P/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/scripts/OgreLeaks.log
===================================================================
--- /GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/scripts/OgreLeaks.log	(revision 777)
+++ 	(revision )
@@ -1,7 +1,0 @@
- ---------------------------------------------------------------------------------------------------------------------------------- 
-|                                          Memory leak report for:  07/06/2005 13:55:15                                            |
- ---------------------------------------------------------------------------------------------------------------------------------- 
-
-
-Congratulations! No memory leaks found!
-