Index: GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/include/GameToolsParticleDemo.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/include/GameToolsParticleDemo.h	(revision 1356)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/GameToolsParticleDemo/include/GameToolsParticleDemo.h	(revision 1442)
@@ -116,5 +116,5 @@
 	void createScene(void)
     {
-		//createPostproc();
+		createPostproc();
 
 		OgreIlluminationManager::getSingleton().setMainCamera(mCamera);
Index: GTP/trunk/App/Demos/Illum/Ogre/src/HierarchicalSystem/include/HierarchicalSystem.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/HierarchicalSystem/include/HierarchicalSystem.h	(revision 1423)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/HierarchicalSystem/include/HierarchicalSystem.h	(revision 1442)
@@ -50,5 +50,5 @@
 		float t = (float) framecount / 50.0;
 		float r = 150;
-		lightNode->setPosition( r * sin(t), r * sin(5 * t) , r * cos(t));
+		lightNode->setPosition( r * sin(t), r * sin(5 * t) + 200 , r * cos(t));
 
        framecount++;
@@ -123,5 +123,5 @@
 	void createScene(void)
     {
-		//createPostproc();
+		createPostproc();
 
 		OgreIlluminationManager::getSingleton().setMainCamera(mCamera);
@@ -129,5 +129,5 @@
 				
 		Root::getSingleton()._setCurrentSceneManager(mSceneMgr);
-		mCamera->setPosition(0,0,100);
+		mCamera->setPosition(0,150,100);
 		mCamera->setDirection(0,0,-1);
 		mCamera->setFOVy(Radian(Degree(80)));
@@ -137,5 +137,5 @@
 
 		// Skybox
-        mSceneMgr->setSkyBox(true, "Examples/MorningSkyBox", 10);
+        mSceneMgr->setSkyBox(true, "Examples/EveningSkyBox", 10);
 		SceneNode* rootNode = mSceneMgr->getRootSceneNode();
 					
@@ -147,30 +147,25 @@
 		kupolaNode = rootNode->createChildSceneNode( "kupola" );
 		kupolaNode->rotate(Vector3(0,1,0),Radian(Degree(90)));
+		//kupolaNode->setPosition(0, -150, 0);
 		kupolaNode->attachObject( kupola );
-		kupolaNode->scale(25,21,25);		
+		kupolaNode->scale(50,50,50);		
 		kupolaNode->_updateBounds();
 		MeshPtr kmesh = kupola->getMesh();
 		kmesh->buildTangentVectors(0,1);*/
-		
-		Entity* head = mSceneMgr->createEntity("head", "ogrehead.mesh");
+
+		Entity* head = mSceneMgr->createEntity("head", "athene.mesh");
 		SceneNode* headNode = rootNode->createChildSceneNode("head");
+		head->setMaterialName("GameTools/Standard");
 		headNode->attachObject(head);
-		//headNode->setScale(0.5,0.5,0.5);
+		//headNode->setScale(1.5,1.5,1.5);
 		AxisAlignedBox bbox = head->getBoundingBox();
-		headNode->setPosition(0,0,0);		
+		headNode->setPosition(0,180,20);		
 		headNode->_updateBounds();
-
-		/*Entity* head2 = mSceneMgr->createEntity("head2", "ogrehead.mesh");
-		SceneNode* headNode2 = rootNode->createChildSceneNode("head2");
-		headNode2->attachObject(head2);
-		headNode2->setScale(2,2,2);
-		headNode2->setPosition(0, 0, 0);*/
 
 		ParticleSystem* pSys1 = mSceneMgr->createParticleSystem("psys1", "GameTools/Big");
 		pSys1->setKeepParticlesInLocalSpace(false);
 		SceneNode *pSysNode = rootNode->createChildSceneNode("psys1");
-		pSysNode->attachObject(pSys1); 
-
-		pSysNode->setPosition(0,0,0);
+		pSysNode->attachObject(pSys1);
+		pSysNode->setPosition(0,100,0);
 		
 		//Init lights
Index: GTP/trunk/App/Demos/Illum/Ogre/src/PRMDemo/scripts/PRMDemo.vcproj
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/PRMDemo/scripts/PRMDemo.vcproj	(revision 1086)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/PRMDemo/scripts/PRMDemo.vcproj	(revision 1442)
@@ -102,5 +102,5 @@
 				Name="VCLinkerTool"
 				AdditionalDependencies="OgreMain.lib IllumModule_Ogre.lib IllumModule.lib"
-				OutputFile="$(OutDir)/GameToolsParticleDemo.exe"
+				OutputFile="$(OutDir)/PRMDemo.exe"
 				LinkIncremental="1"
 				AdditionalLibraryDirectories="..\..\..\..\..\..\..\Lib\Illum\IllumModule\OgreIllumModule\bin\Release;&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;..\..\..\..\..\..\..\Lib\Illum\IllumModule\IllumModule\bin\Release"