Index: /GTP/trunk/Lib/Vis/Preprocessing/src/RssPreprocessor.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/RssPreprocessor.cpp	(revision 1449)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/RssPreprocessor.cpp	(revision 1454)
@@ -513,5 +513,5 @@
   if (!mLoadViewCells)
   {
-	if (0) 
+	if (1) 
 	  mViewCellsManager->SetViewSpaceBox(mKdTree->GetBox());
 	else {
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/default.env
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 1387)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 1454)
@@ -6,5 +6,5 @@
 Scene {
 
-# filename ../data/City4M/City4M.obj
+#filename ../data/City4M/City4M.obj
 # filename ../data/CityModel/CityModel.obj
 # filename ../data/GrandCanyon/grandcanyon1_RotXmin90.obj
@@ -13,10 +13,10 @@
 # filename ../data/vienna/vienna-simple.x3d
 # filename ../data/vienna/vienna-buildings.x3d
-filename ../data/vienna/city1500_flat_1.x3d
+# filename ../data/vienna/city1500_flat_1.x3d
 #filename ../data/vienna/vienna-buildings.x3d;../data/vienna/vienna-roofs.x3d
 #;../data/vienna/vienna-plane.x3d;../data/vienna/vienna-roads.x3d
 # filename ../data/vienna/viewcells-25-sel.x3d
 #filename ../data/atlanta/atlanta2.x3d
-# filename ../data/soda/soda.dat
+filename ../data/soda/soda.dat
 #filename ../data/test1/test2.x3d
 #filename ../data/soda/soda5.dat
@@ -53,5 +53,5 @@
 	visibilityFilterWidth	0.01
 	visibilityFile visibility.xml
-	loadPolygonsAsMeshes false
+	loadMeshes true
 }
 
@@ -301,6 +301,6 @@
 
 #	filename ../data/soda/soda5-viewcell-single.xm
-#	filename ../data/soda/vienna-viewcell-single.xml
-	filename ../data/CityModel/CityModel-viewcells-5000.xml
+	filename ../data/soda/soda-viewcells-1000.xml.zip
+#	filename ../data/CityModel/CityModel-viewcells-5000.xml
 #	filename ../data/City4M/City4M-viewcells-5000.xml
 
@@ -312,4 +312,5 @@
 #	filename ../data/vienna/vienna_simple-21-04-avs2-viewCells.xml
 #	filename ../data/vienna/vienna-viewcells-5000.xml
+#	filename ../data/vienna/vienna-viewcells-1000.xml.zip
 
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1449)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1454)
@@ -1835,5 +1835,5 @@
 			if (ray.mTerminationObject) 
 			{
-				cout << "f";
+			  //				cout << "f";
 				if (viewcell->GetPvs().GetSampleContribution(ray.mTerminationObject,
 					ray.mPdf,
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 1387)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 1454)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (2.00a) (Qt 4.1.2) on: so 16. IX 21:15:03 2006
+# Generated by qmake (2.00a) (Qt 4.1.2) on: ?t 21. IX 20:46:44 2006
 # Project:  preprocessor.pro
 # Template: app
@@ -71,7 +71,4 @@
 		C:\Qt\4.1.2\mkspecs\features\debug_and_release.prf \
 		C:\Qt\4.1.2\mkspecs\features\default_post.prf \
-		C:\Qt\4.1.2\mkspecs\features\qt.prf \
-		C:\Qt\4.1.2\mkspecs\features\win32\opengl.prf \
-		C:\Qt\4.1.2\mkspecs\features\moc.prf \
 		C:\Qt\4.1.2\mkspecs\features\win32\thread.prf \
 		C:\Qt\4.1.2\mkspecs\features\warn_off.prf \
@@ -92,7 +89,4 @@
 C:\Qt\4.1.2\mkspecs\features\debug_and_release.prf:
 C:\Qt\4.1.2\mkspecs\features\default_post.prf:
-C:\Qt\4.1.2\mkspecs\features\qt.prf:
-C:\Qt\4.1.2\mkspecs\features\win32\opengl.prf:
-C:\Qt\4.1.2\mkspecs\features\moc.prf:
 C:\Qt\4.1.2\mkspecs\features\win32\thread.prf:
 C:\Qt\4.1.2\mkspecs\features\warn_off.prf:
@@ -116,16 +110,4 @@
 distclean: release-distclean debug-distclean FORCE
 	-$(DEL_FILE) Makefile
-
-release-mocclean: $(MAKEFILE).Release
-	$(MAKE) -f $(MAKEFILE).Release mocclean
-debug-mocclean: $(MAKEFILE).Debug
-	$(MAKE) -f $(MAKEFILE).Debug mocclean
-mocclean: release-mocclean debug-mocclean
-
-release-mocables: $(MAKEFILE).Release
-	$(MAKE) -f $(MAKEFILE).Release mocables
-debug-mocables: $(MAKEFILE).Debug
-	$(MAKE) -f $(MAKEFILE).Debug mocables
-mocables: release-mocables debug-mocables
 FORCE:
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 1418)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 1454)
@@ -220,4 +220,5 @@
 
 	bool guiSupported = false;
+
 	if (preprocessor->mUseGlRenderer || preprocessor->mUseGlDebugger)
 	  {
@@ -264,5 +265,5 @@
 	  // just call the mail method -> will be executed in the main thread
 #if USE_THREADS
-	  pt->RunThread();
+	  pt->Main();
 #endif
 	}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ObjParser.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ObjParser.cpp	(revision 1421)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ObjParser.cpp	(revision 1454)
@@ -210,5 +210,5 @@
 		case 'f': 
 			{
-				cout << "f";
+			  //				cout << "f";
 
 				if (loadMeshes)
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 1387)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 1454)
@@ -1,4 +1,5 @@
 CONFIG -= qt debug
-CONFIG	+= console warn_off thread release mlrt qt
+CONFIG	+= console warn_off thread release
+#mlrt qt
 
 TEMPLATE = app