Index: /GTP/trunk/Lib/Vis/Preprocessing/src/QtPreprocessorThread.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/QtPreprocessorThread.cpp	(revision 1387)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/QtPreprocessorThread.cpp	(revision 1457)
@@ -20,44 +20,4 @@
 }
 
-void
-QtPreprocessorThread::Main()
-{
-  
-  Camera camera;
-  
-  if (0)
-	{
-		// camera.LookAtBox(mPreprocessor->mKdTree->GetBox());
-		//	camera.LookInBox(mPreprocessor->mKdTree->GetBox());
-		camera.SetPosition(Vector3(3473, 6.778f, -1699.0f));
-		camera.SetDirection(Vector3(-0.2432f, 0, 0.97f));
-		//	camera.SetPosition(Vector3(991.7, 187.8, -271));
-		//	camera.SetDirection(Vector3(0.9, 0, -0.4));
-
-		camera.SnapImage("camera.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
-	} 
-  
-  if (0) {
-	camera.LookInBox(mPreprocessor->mKdTree->GetBox());
-	camera.SetPosition(camera.mPosition + Vector3(-250,0,-550));
-	camera.SnapImage("camera2.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
-  }
-
-  if (0) {
-	camera.SetPosition( mPreprocessor->mKdTree->GetBox().Center() - Vector3(0,-100,0) );
-	camera.SetDirection(Vector3(1, 0, 0));
-	camera.SnapImage("camera3.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
-  }
-  
-  if (mPreprocessor->mComputeVisibility) {
-	mPreprocessor->ComputeVisibility();
-	//	mPreprocessor->ExportPreprocessedData("scene.vis");
-	mPreprocessor->PostProcessVisibility();
-  }
-  
-  cerr << "Preprocessor main finished...\n";
-  
-  
-}
 
 QtPreprocessorThread::~QtPreprocessorThread()
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/PreprocessorThread.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/PreprocessorThread.cpp	(revision 1159)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/PreprocessorThread.cpp	(revision 1457)
@@ -1,3 +1,7 @@
 #include "PreprocessorThread.h"
+#include "Camera.h"
+#include "KdTree.h"
+#include "SceneGraph.h"
+#include "Preprocessor.h"
 
 
@@ -15,4 +19,43 @@
 }
 
+void
+PreprocessorThread::Main()
+{
+  Camera camera;
+  
+  if (0)
+	{
+		// camera.LookAtBox(mPreprocessor->mKdTree->GetBox());
+		//	camera.LookInBox(mPreprocessor->mKdTree->GetBox());
+		camera.SetPosition(Vector3(3473, 6.778f, -1699.0f));
+		camera.SetDirection(Vector3(-0.2432f, 0, 0.97f));
+		//	camera.SetPosition(Vector3(991.7, 187.8, -271));
+		//	camera.SetDirection(Vector3(0.9, 0, -0.4));
+
+		camera.SnapImage("camera.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
+	} 
+  
+  if (0) {
+	camera.LookInBox(mPreprocessor->mKdTree->GetBox());
+	camera.SetPosition(camera.mPosition + Vector3(-250,0,-550));
+	camera.SnapImage("camera2.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
+  }
+
+  if (0) {
+	camera.SetPosition( mPreprocessor->mKdTree->GetBox().Center() - Vector3(0,-100,0) );
+	camera.SetDirection(Vector3(1, 0, 0));
+	camera.SnapImage("camera3.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
+  }
+  
+  if (mPreprocessor->mComputeVisibility) {
+	mPreprocessor->ComputeVisibility();
+	//	mPreprocessor->ExportPreprocessedData("scene.vis");
+	mPreprocessor->PostProcessVisibility();
+  }
+  
+  cerr << "Preprocessor main finished...\n";
+  
+}
+
 
 /*PreprocessorThread *PreprocessorThreadFactory::Create(const int threadType)
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/BoostPreprocessorThread.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/BoostPreprocessorThread.cpp	(revision 1404)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/BoostPreprocessorThread.cpp	(revision 1457)
@@ -21,41 +21,4 @@
 
 
-void BoostPreprocessorThread::Main()
-{
-  Camera camera;
-
-  if (0)
-	{
-		// camera.LookAtBox(mPreprocessor->mKdTree->GetBox());
-		//	camera.LookInBox(mPreprocessor->mKdTree->GetBox());
-		camera.SetPosition(Vector3(3473, 6.778f, -1699.0f));
-		camera.SetDirection(Vector3(-0.2432f, 0, 0.97f));
-		//	camera.SetPosition(Vector3(991.7, 187.8, -271));
-		//	camera.SetDirection(Vector3(0.9, 0, -0.4));
-
-		camera.SnapImage("camera.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
-	} 
-  
-  if (0) {
-	camera.LookInBox(mPreprocessor->mKdTree->GetBox());
-	camera.SetPosition(camera.mPosition + Vector3(-250,0,-550));
-	camera.SnapImage("camera2.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
-  }
-
-  if (0) {
-	camera.SetPosition( mPreprocessor->mKdTree->GetBox().Center() - Vector3(0,-100,0) );
-	camera.SetDirection(Vector3(1, 0, 0));
-	camera.SnapImage("camera3.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
-  }
-  
-  if (mPreprocessor->mComputeVisibility) {
-	mPreprocessor->ComputeVisibility();
-	//	mPreprocessor->ExportPreprocessedData("scene.vis");
-	mPreprocessor->PostProcessVisibility();
-  }
-  
-  cerr << "Preprocessor main finished...\n";
-  
-}
 
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/PreprocessorThread.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/PreprocessorThread.h	(revision 1387)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/PreprocessorThread.h	(revision 1457)
@@ -16,8 +16,9 @@
   virtual ~PreprocessorThread();
   
-  virtual void InitThread() = 0;
-  virtual void RunThread() = 0;
-
-  virtual void Main() = 0;
+  virtual void InitThread() {}
+  virtual void RunThread() {}
+  
+  virtual void Main();
+  
 protected:
   
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 1454)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 1457)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (2.00a) (Qt 4.1.2) on: ?t 21. IX 20:46:44 2006
+# Generated by qmake (2.00a) (Qt 4.1.2) on: ?t 21. IX 22:34:57 2006
 # Project:  preprocessor.pro
 # Template: app
@@ -71,4 +71,7 @@
 		C:\Qt\4.1.2\mkspecs\features\debug_and_release.prf \
 		C:\Qt\4.1.2\mkspecs\features\default_post.prf \
+		C:\Qt\4.1.2\mkspecs\features\qt.prf \
+		C:\Qt\4.1.2\mkspecs\features\win32\opengl.prf \
+		C:\Qt\4.1.2\mkspecs\features\moc.prf \
 		C:\Qt\4.1.2\mkspecs\features\win32\thread.prf \
 		C:\Qt\4.1.2\mkspecs\features\warn_off.prf \
@@ -89,4 +92,7 @@
 C:\Qt\4.1.2\mkspecs\features\debug_and_release.prf:
 C:\Qt\4.1.2\mkspecs\features\default_post.prf:
+C:\Qt\4.1.2\mkspecs\features\qt.prf:
+C:\Qt\4.1.2\mkspecs\features\win32\opengl.prf:
+C:\Qt\4.1.2\mkspecs\features\moc.prf:
 C:\Qt\4.1.2\mkspecs\features\win32\thread.prf:
 C:\Qt\4.1.2\mkspecs\features\warn_off.prf:
@@ -110,4 +116,16 @@
 distclean: release-distclean debug-distclean FORCE
 	-$(DEL_FILE) Makefile
+
+release-mocclean: $(MAKEFILE).Release
+	$(MAKE) -f $(MAKEFILE).Release mocclean
+debug-mocclean: $(MAKEFILE).Debug
+	$(MAKE) -f $(MAKEFILE).Debug mocclean
+mocclean: release-mocclean debug-mocclean
+
+release-mocables: $(MAKEFILE).Release
+	$(MAKE) -f $(MAKEFILE).Release mocables
+debug-mocables: $(MAKEFILE).Debug
+	$(MAKE) -f $(MAKEFILE).Debug mocables
+mocables: release-mocables debug-mocables
 FORCE:
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 1454)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 1457)
@@ -2,6 +2,11 @@
 //#define USE_QT 0
 #endif
-//#define USE_QT 0
-#define USE_THREADS 1
+
+#define USE_QT 0
+#if USE_QT
+#define USE_BOOST 0
+#else
+#define USE_BOOST 0
+#endif
 
 #ifdef UNICODE
@@ -27,5 +32,6 @@
 #include "SceneGraph.h"
 
-#if USE_THREADS && !USE_QT
+#include "PreprocessorThread.h"
+#if USE_BOOST
 #include "BoostPreprocessorThread.h"
 #endif
@@ -209,5 +215,4 @@
 	// create a preprocessor thread (note: capsulates calls to boost fuctions!)
 	//PreprocessorThread *pt = PreprocessorThreadFactory::Create(preprocessor);
-#if USE_THREADS
 	PreprocessorThread *pt;
 
@@ -215,6 +220,9 @@
 	pt = new QtPreprocessorThread(preprocessor);
 #else
+#if USE_BOOST
 	pt = new BoostPreprocessorThread(preprocessor);
-#endif
+#else
+	pt = new PreprocessorThread(preprocessor);
+#endif	
 #endif
 
@@ -225,4 +233,5 @@
 		cout << "using gl widget" << endl;
 		// create and run the preprocessor application in a parallel thread
+#if USE_QT		
 #if USE_THREADS
 		pt->InitThread();
@@ -230,5 +239,4 @@
 #endif
 		
-#if USE_QT		
 		// display the render widget
 		if (!rendererWidget) 
@@ -264,7 +272,5 @@
 	if (!(preprocessor->mUseGlRenderer || preprocessor->mUseGlDebugger)) {
 	  // just call the mail method -> will be executed in the main thread
-#if USE_THREADS
 	  pt->Main();
-#endif
 	}
 	
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/BoostPreprocessorThread.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/BoostPreprocessorThread.h	(revision 1146)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/BoostPreprocessorThread.h	(revision 1457)
@@ -22,5 +22,4 @@
 	virtual void RunThread();
 
-	virtual void Main();
 
 	void operator()();
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 1454)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 1457)
@@ -1,5 +1,4 @@
 CONFIG -= qt debug
-CONFIG	+= console warn_off thread release
-#mlrt qt
+CONFIG	+= console warn_off thread release mlrt qt
 
 TEMPLATE = app
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/QtPreprocessorThread.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/QtPreprocessorThread.h	(revision 1387)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/QtPreprocessorThread.h	(revision 1457)
@@ -16,5 +16,4 @@
   ~QtPreprocessorThread();
   
-  void Main();
   void InitThread() {}
   void RunThread() {